// 監視を開始する
function addPrefListener(aObserver) {
	try {
		var pbi = Components.classes['@mozilla.org/preferences;1'].getService(Components.interfaces.nsIPrefBranchInternal);
		pbi.addObserver(aObserver.domain, aObserver, false);
	} catch(e) {}
}

// 監視を終了する
function removePrefListener(aObserver) {
	try {
		var pbi = Components.classes['@mozilla.org/preferences;1'].getService(Components.interfaces.nsIPrefBranchInternal);
		pbi.removeObserver(aObserver.domain, aObserver);
	} catch(e) {}
}

function setPrefValue(aPrefString, aPrefType, aValue){
	var nsIPrefBranch = Components.interfaces.nsIPrefBranch;
	var xpPref = Components.classes["@mozilla.org/preferences;1"]
	  .getService(Components.interfaces.nsIPrefBranch);
	var prefType = xpPref.getPrefType(aPrefString);
	
	try{
		switch (aPrefType){
		  case "str":
			return xpPref.setCharPref(aPrefString, aValue);	break;
		  case "strW":
		  	var nsISupportsString = Components.interfaces.nsISupportsString;
			var string = Components.classes['@mozilla.org/supports-string;1']
                  .createInstance(nsISupportsString) ;
			string.data = aValue;
			return xpPref.setComplexValue(aPrefString, nsISupportsString, string); break;
		  case "int":
			aValue = parseInt(aValue); // 文字列を整数値に変換
			return xpPref.setIntPref(aPrefString, aValue);	break;
		  case "bool":
		  default:
			aValue = (aValue == "true"); // 文字列を真偽値に変換
			return xpPref.setBoolPref(aPrefString, aValue);	break;
		}
	}catch(e){
	}
	return null;
}

function getPrefValue(aPrefString, aPrefType, aDefault){
	var xpPref = Components.classes["@mozilla.org/preferences;1"]
	  .getService(Components.interfaces.nsIPrefBranch);
	
	if(xpPref.getPrefType(aPrefString) == xpPref.PREF_INVALID){
		return aDefault;
	}
	try{
		switch (aPrefType){
		  case "str":
			return xpPref.getCharPref(aPrefString).toString(); break;
		  case "strW":
			var nsISupportsString = Components.interfaces.nsISupportsString;
			return xpPref.getComplexValue(aPrefString, nsISupportsString).data; break;
		  case "int":
			return xpPref.getIntPref(aPrefString).toString(); break;
		  case "bool":
		  default:
			return xpPref.getBoolPref(aPrefString).toString(); break;
		}
	}catch(e){
	}
	return aDefault;
}

function clearPref(aPrefString){
	var xpPref = Components.classes["@mozilla.org/preferences;1"]
	  .getService(Components.interfaces.nsIPrefBranch);
	
	var result = false;
	
	try{
		xpPref.clearUserPref(aPrefString);
		result = true
	  }catch(e){
	  }
	return result;
}